unit UTWeatherClass;

interface

uses
  uLkJSON;

type

  TCoord = record
  	Lat:double;
    Lon:double;
  end;

  TCiudad = record
    nombre:string;
    pais:string;
    coord:TCoord;
  end;

  TListaCiudades = record
    cod:integer;
    cont:integer;
    ciudades:array of TCiudad;
  end;

  TSys = record
  	tipo:integer;
  	msg:double;
    country:String;
    sunrise:TDateTime;
    sunset:TDateTime;
  end;

  TWeather = record
  	id:integer;
    main: string;
    desc: string;
    icon: string;
  end;

  // Main para tiempo
  TMain = record
  	temp:double;        // temperatura
    humidity:double;    // humedad %
    pressure:double;
    tempmin:double;
    tempmax:double;
    sealevel:Double;   // atm  presure
    grnlevel:Double;
  end;

  // Viento
  TWind = record
  	speed:double;			// mps
    deg:integer;  		// direccion
    gust:double; 			// rafagas  mps
  end;

  TRain = record
  	Last3h:integer;  // Prec. en mm de las ult. 3 horas
  end;

  TSnow = record
  	Last3h:integer;  // Nieve volumen en mm de las ult. 3 horas
  end;

  TClouds = record
		All:Integer;			// % nublado.
  end;

  TTiempoProxHora = record
    dt:TDateTime;
    dt_text:string;
    main:TMain;
    weather: TWeather;
  end;

  TTiempoProxHoras = record
    Cod:Integer;			// cod. tiempo
    TiempoHora:array of TTiempoProxHora;
  End;

	TTiempoStruct = record
  	dt:Int64;					// Fecha recepcion
    id:Int64;	  			// id. ciudad
    name:wideString;			// nombre cioudad
    Base:widestring;
    Cod:Integer;			// cod. tiempo
  	Coord:TCoord;
    Sys:TSys;
    Weather: array of TWeather;
    Main: TMain;
    Wind:TWind;
    Rain:TRain;
    Clouds:TClouds;
    Snow:TSnow;
  end;

  TCity = record
  	id:integer;
    name:string;
    coord:TCoord;
    country:string;
    population:Integer;
  end;

  TTemp = record
  	day:double;
    min:double;
    max:double;
    night:double;
    eve:double;
    morn:double;
  end;

  TDayForecast = record
  	dt:int64;
		temp:TTemp;
    presure:double;
    humidity:Integer;
    Weather: array of TWeather;
    speed:Double;
    deg:Integer;
    cloud:Integer;
  end;

  TForecastStruct = record
  	cod:string;
    msg:Double;
		city:TCity;
    dayscount:Integer;
    days: array of TDayForecast;
  end;

  // procedimientos y funciones generales
  function IsErrorResponse(AObjResp: TlkJSONobject;
  												var ErrCode:Integer; var ErrMessage:string):Boolean;


//=========================================================================
//
// I M P L E M E N T A T I O N
//
//=========================================================================
implementation

uses
	UCommonProcedures;


// procedimientos y funciones generales
function IsErrorResponse(AObjResp: TlkJSONobject;
												 var ErrCode:Integer; var ErrMessage:string):Boolean;
var
  o1, o2:TlkJSONBase;
begin
	// ini
  Result := False;
  o1 := nil;
  o2 := nil;                                    

  // Objeto Data
  o1 := AObjResp.Field['cod'];
  o2 := AObjResp.Field['message'];
  // Est el mensaje y el error?
  if Assigned(o1) then begin
    ErrCode := GetAsInteger(o1.Value);
    // Correcto?
    if (ErrCode = 200) then begin
      Result := False;  //todo OK=200
    end
    else begin
      // Buscar el error
      if Assigned(o2) then begin
        Result := True;
        ErrCode := GetAsInteger(o1.Value);
        ErrMessage := GetAsString(o2.Value);
      end;
    end;
  end;
end;

end.
